<template>
<el-container>
	<el-header>
		<div class="left-panel">
		</div>
		<div class="right-panel">
			<div class="right-panel-search">
				<el-input v-model="search.title" placeholder="名称" clearable></el-input>
				<el-button type="primary" icon="el-icon-search" @click="upsearch"></el-button>
			</div>
		</div>
	</el-header>
	<el-main class="nopadding">
		<scTable ref="table" :apiObj="list.apiObj" :column="list.column" row-key="id" @selection-change="selectionChange" :params="search">
			<el-table-column type="selection" />
			<template #status="scope">
				<el-tag :type="scope.row.status == 1 ? 'success' : 'error'">{{ scope.row.status == 1 ? '启用' : '禁用' }}</el-tag>
			</template>
			<template #operation="scope">
				<el-button type="primary" @click="update(scope.row, scope.$index)">更新</el-button>
			</template>
		</scTable>
	</el-main>
</el-container>
</template>

<script>

export default {
	name: 'system.client',
	data(){
		return {
			dialog: {search: false, menu: false, save: false},
			list: {
				apiObj: this.$API.system.modules.list,
				column: [
					{prop: 'id', label: 'ID', width: 80},
					{prop: 'title', label: '模块名称'},
					{prop: 'name', label: '模块标识', width: 180},
					{prop: 'status', label: '状态', width: 260},
					{prop: 'created_at', label: '添加时间', width: 160},
					{prop: 'updated_at', label: '更新时间', width: 160},
					{prop: 'operation', label: '操作', width: 80, fixed: 'right'}
				],
			},
			searchFields: [
				{title: '标题', key: 'title', type: 'string'},
			],
			actions: {
				add: {title: '', icon: 'a-icon-plus-outlined', type: 'primary'},
			},
			selection: [],
			search: {},
		}
	},
	mounted(){
	},
	methods:{
		upsearch(){
			this.$refs.table.reload(this.search);
		},
		moreUpsearch(search){
			this.search = search;
			this.upsearch();
		},
		moreSearch(){
			this.dialog.search = true
			this.$nextTick(() => {
				this.$refs.searchBox.open().setData(this.search)
			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
			console.log(selection)
		},
		add(){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open('add').setData({})
			})
		},
		edit(item){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open('edit').setData(item)
			})
		},
		table_show(item){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open('show').setData(item)
			})
		},
		client_menu(item){
			this.dialog.menu = true
			this.$nextTick(() => {
				this.$refs.menuBox.open().setData(item)
			})
		},
		async update(item){
			let res = await this.$API.system.modules.update.post({name: item.name});
			if(res.code == 1){
				//这里选择刷新整个表格 OR 插入/编辑现有表格数据
				this.upsearch()
				this.$message.success("更新成功")
			}else{
				this.$message.error(res.message)
			}
		}
	}
}
</script>

<style scoped>
</style>
